/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"

#include <stdio.h>
#include <stdarg.h>

static void cpp_diagnostika(cpp_cshii *cshii,
                            enum cpp_diagnostickaa_uurovenh uu,
                            const char *spraava,
                            va_list *vl)
{
    lokaacia_t lok;
    
    if (!(cshii->spaetneevolania.diagnostika))
    {
        printf("cshii->spaetneevolania.diagnostika je NULL\n");
        abort();
    }

    if (cshii->akt_token == cshii->akt_tokenrad->shtart)
    {
        lok.suubor = NULL;
    }
    else
    {
        lok = cshii->akt_token[-1].lokaacia;
    }
    
    cshii->spaetneevolania.diagnostika(cshii, uu, lok, spraava, vl);
}

void cpp_chyba(cpp_cshii *cshii, enum cpp_diagnostickaa_uurovenh uu,
               const char *spraava, ...)
{
    va_list vl;

    va_start(vl, spraava);

    cpp_diagnostika(cshii, uu, spraava, &vl);

    va_end(vl);
}
