/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

static tabsym_r *alokuj_r(void)
{
    void *r = malloc(sizeof(cpp_neviem));
    if (r == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    memset(r, '\0', sizeof(cpp_neviem));
    return (r);
}

void _cpp_inic_tabsym(cpp_cshii *cshii, tabsym *tabulhka)
{
    struct shpec_neviem *s;
    
    if (tabulhka == NULL)
    {
        tabulhka = tabsym_vytvor_tabsym(1024 /* Naahodnee cshiislo. */,
                                        &alokuj_r);
        if (tabulhka == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }
        cshii->vlastnaa_tabulhka = 1;
    }
    else cshii->vlastnaa_tabulhka = 0;

    cshii->tab = tabulhka;

    _cpp_inic_direktiivy(cshii);

    s = &(cshii->shpec_neviem);
#define RETHAZEC_A_DLLZHKA(r) (const unsigned char *)r, sizeof(r) - 1
    s->n_defined = cpp_najdi(cshii, RETHAZEC_A_DLLZHKA("defined"));
    s->n___VA_ARGS__ = cpp_najdi(cshii, RETHAZEC_A_DLLZHKA("__VA_ARGS__"));
}

cpp_neviem *cpp_najdi(cpp_cshii *cshii, const unsigned char *rethazec,
                      unsigned int dllzhka)
{
    return (CPP_NEVIEM(tabsym_najdi(cshii->tab, rethazec, dllzhka)));
}
