/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef CPPKNI_H
#define CPPKNI_H

#include "tabsym.h"

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

typedef struct cpp_cshii cpp_cshii;
typedef struct cpp_nastavenia cpp_nastavenia;
typedef struct cpp_token cpp_token;
typedef struct cpp_rethazec cpp_rethazec;
typedef struct cpp_neviem cpp_neviem;
typedef struct cpp_makro cpp_makro;
typedef struct cpp_adresaar cpp_adresaar;

typedef struct {
    const char *suubor;
    unsigned long riadok;
    int stllpec;
} lokaacia_t;

#define TABULHKA_TYPOV \
JANEVIEM(ROVNAA_SA, "=") \
JANEVIEM(NIE, "!") \
JANEVIEM(VAECSHIE, ">") \
JANEVIEM(MENSHIE, "<") \
JANEVIEM(PLUS, "+") \
JANEVIEM(MIINUS, "-") \
JANEVIEM(HVIEZDA, "*") \
JANEVIEM(LOMKA, "/") \
JANEVIEM(MODULO, "%") \
JANEVIEM(A, "&") \
JANEVIEM(ALEBO, "|") \
JANEVIEM(XALEBO, "^") \
JANEVIEM(LH_POSUN, "<<") \
JANEVIEM(P_POSUN, ">>") \
\
JANEVIEM(KOMPLEMENT, "~") \
JANEVIEM(A_A, "&&") \
JANEVIEM(ALEBO_ALEBO, "||") \
JANEVIEM(OTAAZNIK, "?") \
JANEVIEM(DVOJBODKA, ":") \
JANEVIEM(CSHIARKA, ",") \
JANEVIEM(LH_ZAATVORKA, "(") \
JANEVIEM(P_ZAATVORKA, ")") \
JANEVIEM2(KONIEC, ZHIADNE) \
JANEVIEM(ROVNAA_SA_ROVNAA_SA, "==") \
JANEVIEM(NIE_ROVNAA_SA, "!=") \
JANEVIEM(VAECSHIE_ROVNAA_SA, ">=") \
JANEVIEM(MENSHIE_ROVNAA_SA, "<=") \
\
/* Na mieste tyychto tokenov sa nachaadza \
* vo vyyraz.c CPP_UPLUS a CPP_UMIINUS. */ \
JANEVIEM(PLUS_ROVNAA_SA, "+=") \
JANEVIEM(MIINUS_ROVNAA_SA, "-=") \
\
JANEVIEM(HVIEZDA_ROVNAA_SA, "*=") \
JANEVIEM(LOMKA_ROVNAA_SA, "/=") \
JANEVIEM(MODULO_ROVNAA_SA, "%=") \
JANEVIEM(A_ROVNAA_SA, "&=") \
JANEVIEM(ALEBO_ROVNAA_SA, "|=") \
JANEVIEM(XALEBO_ROVNAA_SA, "^=") \
JANEVIEM(LH_POSUN_ROVNAA_SA, "<<=") \
JANEVIEM(P_POSUN_ROVNAA_SA, ">>=") \
/* Digrafy. */ \
JANEVIEM(MREZHA, "#") \
JANEVIEM(ZLEP, "##") \
JANEVIEM(LH_HZAATVORKA, "[") \
JANEVIEM(P_HZAATVORKA, "]") \
JANEVIEM(LH_KZAATVORKA, "{") \
JANEVIEM(P_KZAATVORKA, "}") \
\
JANEVIEM(BODKOCSHIARKA, ";") \
JANEVIEM(ELIPSA, "...") \
JANEVIEM(BODKA, ".") \
JANEVIEM(DEREF, "->") \
JANEVIEM(PLUS_PLUS, "++") \
JANEVIEM(MIINUS_MIINUS, "--") \
JANEVIEM(ZAVINAACSH, "@") \
\
JANEVIEM2(IDENT, IDENT) \
JANEVIEM2(CSHIISLO, LITERAAL) \
\
JANEVIEM2(ZNAK, LITERAAL) \
JANEVIEM2(LZNAK, LITERAAL) \
JANEVIEM2(uZNAK, LITERAAL) \
JANEVIEM2(UZNAK, LITERAAL) \
JANEVIEM2(INEE, LITERAAL) /* Osamelaa interpunkcia. */ \
\
JANEVIEM2(RETHAZEC, LITERAAL) \
JANEVIEM2(LRETHAZEC, LITERAAL) \
JANEVIEM2(uRETHAZEC, LITERAAL) \
JANEVIEM2(URETHAZEC, LITERAAL) \
JANEVIEM2(u8RETHAZEC, LITERAAL) \
JANEVIEM2(NAAZOV_HLAVICSHKY, LITERAAL) \
\
JANEVIEM2(MAKRO_ARGUMENT, ZHIADNE) \
JANEVIEM2(NICSH, ZHIADNE) 

#define JANEVIEM(a, b) CPP_ ## a,
#define JANEVIEM2(a, b) CPP_ ## a,
enum cpp_typtokenu {
    TABULHKA_TYPOV

    CPP_KONIEC_TABULHKY,

    CPP_POSLEDNYY_CPP_OP = CPP_MENSHIE_ROVNAA_SA,
    CPP_PRVYY_DIGRAF = CPP_MREZHA
};
#undef JANEVIEM
#undef JANEVIEM2

enum jazyk_c {
    SHTD_C89, SHTD_C17
};

#define ZA_MEDZEROU 0x1
#define ZACSHIATOK_RIADKA 0x2
#define ZRETHAZCUJ_ARGUMENT 0x4
#define ZLEP_LHAVO 0x8 /* Token na lhavo od ##. */
#define NEEXPANDUJ 0x10
#define DIGRAF 0x20
#define ZZ_DIGRAF 0x40 /* Ak #, alebo ## bol digraf. */
#define ZZ_ZA_MEDZEROU 0x80 /* Ak bola medzera pred ##,
                               alebo pred tyymto tokenom za # operaatorom. */

struct cpp_rethazec {
    unsigned int dllzhka;
    const unsigned char *text;
};

struct cpp_makro_argument {
    unsigned int cshiislo; /* Ide od 0. */
    cpp_neviem *piisanie;
};

struct cpp_token {
    int typ;
    int vlajky;
    lokaacia_t lokaacia;
    union {
        /* Identifikaator. */
        cpp_neviem *neviem;

        /* Zdedii medzery od tohto tokenu. */
        const cpp_token *zdroj;

        /* Rethazec alebo cshiislo. */
        struct cpp_rethazec rethazec;
        
        struct cpp_makro_argument makro_argument;

        /* Originaalne cshiislo tokenu pre CPP_ZLEP
         * (zo sekvencie nasledujuucich CPP_ZLEP tokenov v makre). */
        unsigned cshiislo_tokenu;
    } hodnota;
};

struct cpp_makro {
    cpp_neviem **parametre;
    
    unsigned int pocshet;
    unsigned int pocshet_parametrov;
    
    int funkciovee;
    int variadickee;
    int tokeny_naviac; /* Ak 1, tak na konci tokenov suu ulozhenee ##. */
    
    cpp_token tokeny[1];
};

enum {
    NEVIEM_NICSH = 0,
    NEVIEM_MAKRO_PARAMETER,
    NEVIEM_MAKRO,
    NEVIEM_VSTAVANEE_MAKRO
};

enum cpp_vstavanee_typ {
    VS_DATE, /* __DATE__ */
    VS_FILE, /* __FILE__ */
    VS_LINE, /* __LINE__ */
    VS_TIME, /* __TIME__ */
    VS_PRAGMA /* _Pragma */
};

#define NEVIEM_VYPNUTEE 0x1

union _cpp_neviem_hodnota {
    cpp_makro *makro;
    enum cpp_vstavanee_typ vstavanee;
    unsigned int index_parametru;
};

struct cpp_neviem {
    tabsym_r r;
    int typ;
    int vlajky;

    unsigned int je_direktiiva;
    unsigned int index_direktiivy;

    union _cpp_neviem_hodnota hodnota;
};

#define CPP_NEVIEM(r) ((cpp_neviem *)(r))
#define NEVIEM_MENO(neviem) ((neviem)->r.meno)
#define NEVIEM_DLLZHKA(neviem) ((neviem)->r.dllzhka)

struct cpp_nastavenia {
    enum jazyk_c jazyk;
    int trigrafy;
    /* Cshi je p+ a p- povolenee v cshiislach. */
    int rozshiirenee_cshiisla;

    size_t presnosth;
};

struct cpp_adresaar {
    /* NULLou ukoncshenaa rethaz. */
    struct cpp_adresaar *dhalshii;

    /* '\0' ukoncshenee meno. */
    char *meno;
};

enum cpp_diagnostickaa_uurovenh {
    CPP_DUU_VAROVANIE,
    CPP_DUU_CHYBA,
    CPP_DUU_ZLYHANIE,
    CPP_DUU_INTERNAA_CHYBA
};

enum cpp_duovody {
    CPP_D_VSTUP,
    CPP_D_ODCHOD,
    CPP_D_PREMENOVANIE
};

struct cpp_spaetneevolania {
    void (*zmena_riadka)(cpp_cshii *, const cpp_token *,
                         int zbieranie_argumentov);
    void (*zmena_suuboru)(cpp_cshii *, lokaacia_t, int odchod);
    void (*diagnostika)(cpp_cshii *,
                        enum cpp_diagnostickaa_uurovenh,
                        lokaacia_t,
                        const char *, va_list *);
};

#define cpp_makro_s(neviem) ((neviem)->typ \
                             & (NEVIEM_VSTAVANEE_MAKRO | NEVIEM_MAKRO))

cpp_cshii *cpp_vytvor_cshii(enum jazyk_c jazyk, tabsym *tabulhka);
void cpp_nastav_jazyk(cpp_cshii *cshii, enum jazyk_c jazyk);
void cpp_inic_vstavanee(cpp_cshii *cshii, int hosthovanee);

void cpp_nastav_include_rethaze(cpp_cshii *cshii, cpp_adresaar *uuvodzovky,
                                cpp_adresaar *shikmee,
                                int uuvodzovky_ignorujuu_zdrojovyy_adresaar);

struct cpp_spaetneevolania *cpp_daj_spaetneevolania(cpp_cshii *);

void cpp_znicsh_cshii(cpp_cshii *);

cpp_neviem *cpp_najdi(cpp_cshii *, const unsigned char *, unsigned int);

const char *cpp_cshiitaj_hlavnyy_suubor(cpp_cshii *, const char *meno);

const cpp_token *cpp_daj_token(cpp_cshii *);
const cpp_token *cpp_daj_token_s_lokaaciou(cpp_cshii *cshii, lokaacia_t *lok);
const cpp_token *cpp_pozri_token(cpp_cshii *cshii, unsigned int index);

int cpp_vyhni_sa_zlepeniu(cpp_cshii *cshii,
                          const cpp_token *token1,
                          const cpp_token *token2);

unsigned int cpp_token_dllzhka(const cpp_token *token);
unsigned char *cpp_napiish_token(cpp_cshii *cshii, const cpp_token *token,
                                 unsigned char *pamaeth, int ktovie);
const unsigned char *cpp_token_ako_text(const cpp_token *);
unsigned char *cpp_uuvodzovkuj_rethazec(unsigned char *cielh,
                                        const unsigned char *zdroj,
                                        unsigned int dllzhka);
unsigned char *cpp_daj_riadok_do_rethazca(cpp_cshii *cshii,
                                          const unsigned char *meno_direktiivy);
void cpp_vypiish_token(const cpp_token *token, FILE *vyystup);

void cpp_vynucuj_lokaaciu_tokenov(cpp_cshii *cshii, lokaacia_t lok);
void cpp_prestanh_vynucovath_lokaaciu_tokenov(cpp_cshii *cshii);

int cpp_interpretuj_rethazec(cpp_cshii *, const cpp_rethazec *dnu,
                             cpp_rethazec *von, enum cpp_typtokenu);

/* Pomocnee funkcie nech je mozhnee spaarovath cshii s inyymi shtruktuurami. */
void *cpp_daj_pomoc(cpp_cshii *);
void *cpp_nastav_pomoc(cpp_cshii *, void *);
void *cpp_daj_pomoc2(cpp_cshii *);
void *cpp_nastav_pomoc2(cpp_cshii *, void *);

/* Definuje makro z priikazoveeho riadka (-Dmakro). */
void cpp_define(cpp_cshii *cshii, const char *reth);

/* +++Toto by chcelo domyslieth, nech je to 64 bitovee. */
typedef unsigned long cpp_cshasth_cshiisla;

typedef struct {
    cpp_cshasth_cshiisla hornaa;
    cpp_cshasth_cshiisla dolnaa;
    int bezznamienkovee;
    int pretecshenie;
} cpp_cshiislo;

#define CPP_CSHIISLO_KATEGOORIA 0x000F
#define CPP_CSHIISLO_NESPRAAVNE 0x0000
#define CPP_CSHIISLO_CELEE      0x0001
#define CPP_CSHIISLO_DESATINNEE 0x0002

#define CPP_CSHIISLO_SHIRKAA    0x00F0
#define CPP_CSHIISLO_MALEE      0x0010 /* int, float, short */
#define CPP_CSHIISLO_STREDNEE   0x0020 /* long, double */
#define CPP_CSHIISLO_VELHKEE    0x0040 /* long long, long double */

#define CPP_CSHIISLO_KORENH     0x0F00
#define CPP_CSHIISLO_DESIAT     0x0100
#define CPP_CSHIISLO_HEX        0x0200
#define CPP_CSHIISLO_OKTAALNE   0x0400
#define CPP_CSHIISLO_BINAARNE   0x0800

#define CPP_CSHIISLO_BEZZNAMIENKOVEE 0x1000
#define CPP_CSHIISLO_ZAAKLADNEE 0x2000

/* Klasifikuje token CPP_CSHIISLO. Vyysledok je kombinaacia vlajok hore. */
unsigned int cpp_klasifikuj_cshiislo(cpp_cshii *cshii, const cpp_token *token);

cpp_cshiislo cpp_interpretuj_celee_cshiislo(cpp_cshii *cshii,
                                            const cpp_token *token,
                                            unsigned int typ);



void cpp_chyba(cpp_cshii *cshii, enum cpp_diagnostickaa_uurovenh uu,
               const char *spraava, ...);

#endif /* CPPKNI_H */
