/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "tabsym.h"

#include <stdlib.h>

#define TOKENRAD_DLLZHKA 256

#define V_PORIADKU_ZNAMIENO(z, pred_z) \
 (((z == '+') || (z == '-')) \
  && ((pred_z == 'e') || (pred_z == 'E') \
      || (((pred_z == 'p') || (pred_z == 'P')) \
          && CPP_NASTAVENIE(cshii, rozshiirenee_cshiisla))))

#define CPP_NASTAVENIE(cshii, nastavenie) ((cshii)->nastavenia.nastavenie)

#define CPP_ZVYYSH_RIADOK(cshii, ignorovanee) ((cshii)->ppos->riadok++)

union utoken {
    const cpp_token *token;
    const cpp_token **stoken;
};

enum neviem2_typ_tokenov
{
    TOKENY_TYP_PRIAME, /* * */
    TOKENY_TYP_NEPRIAME /* ** */
};

typedef struct cpp_neviem2 {
    struct cpp_neviem2 *dhalshie;
    
    union utoken prvyy;
    union utoken poslednyy;

    cpp_neviem *makro;
    void *pamaeth;

    enum neviem2_typ_tokenov typ_tokenov;
} cpp_neviem2;

typedef struct {
    const unsigned char *poz;

    /* Typ poznaamky. '\\' znamenaa zrushenyy koniec riadka,
     * ' ' znamenaa zrushenyy koniec riadka s medzerami pred '\\',
     * 9 poslednyych znakov trigrafov znamenaa trigraf,
     * 0 znamenaa uzh spracovanuu poznaamku
     * a ostatnee je zle. */
    unsigned int typ;
} _cpp_riadkovaa_poznaamka;

typedef struct cpp_ppos {
    const unsigned char *poz;
    const unsigned char *zacshiatok_riadka;
    const unsigned char *dhalshii_riadok;

    const unsigned char *shtart; /* Smerniik pre free(). */
    const unsigned char *koniec;

    _cpp_riadkovaa_poznaamka *poznaamky; /* Pole poznaamok. */
    unsigned int akt_poznaamka;
    unsigned int pocshet_poznaamok;
    unsigned int kap_poznaamok;

    struct cpp_ppos *predoshlyy;

    struct _cpp_suubor *suubor;
    /* Sledovanie poziicie. */
    const char *meno_suuboru;
    int riadok;

    struct ak_akumulaator *ak_akumulaator;

    /* 1, ak je potrebnee nacshiitath dhalshii riadok. */
    int potrebnyy_dhalshii_riadok;

    /* 1, ak trigrafy a '\\' s koncami riadkov suu uzh spracovanee
     * a nie je potrebnee ich rieshith. */
    int od_faazy3;
} cpp_ppos;

typedef struct tokenrad {
    struct tokenrad *predoshlyy, *dhalshyy;
    cpp_token *shtart, *koniec;
} tokenrad;

struct stav {
    int v_direktiive;
    int blokuj_expanziu;
    int zbieranie_argumentov;
    int zbieranie_naazvov_hlavicshiek;
    int preskakovanie;
    int direktiiva_chce_medzery;

    int va_args_v_poriadku;

    /* Nie 0, ak sa preskakuje vyhodnocovanie cshasti vyyrazu. */
    int preskocsh_vyhodnotenie;
};

struct shpec_neviem {
    cpp_neviem *n_defined; /* "defined" operaator. */
    cpp_neviem *n___VA_ARGS__; /* __VA_ARGS__ */
};

struct direktiiva; /* Kompletnee v direktiivy.c. */

struct cpp_cshii {
    cpp_ppos *ppos;

    tokenrad zaakladnyy_tokenrad;
    tokenrad *akt_tokenrad;
    cpp_token *akt_token;

    unsigned int tokeny_vpredu;

    lokaacia_t nuutenaa_lokaacia;

    const struct direktiiva *direktiiva;

    /* CPP_KONIEC token. */
    cpp_token koniec;
    cpp_token blokuj_zlepenie;

    /* Vyysledok direktiivy. */
    cpp_token vyysledok_direktiivy;

    cpp_neviem2 *neviem2;

    int drzh_tokeny; /* Ak 1, tokeny sa na konci riadka nevyhodia. */

    struct stav stav;

    struct shpec_neviem shpec_neviem;

    unsigned char *makro_pamaeth;
    unsigned int makro_pamaeth_velhkosth;

    tabsym *tab;
    int vlastnaa_tabulhka;

    struct cpp_spaetneevolania spaetneevolania;

    cpp_adresaar *uuvodzovkovee_include; /* "" */
    cpp_adresaar *shikmee_include; /* <> */
    cpp_adresaar zhiadna_hlhadacia_cesta; /* Zhiadna cesta. */

    /* #include "" ignoruje adresaar, v ktorom sa nachaadza. */
    int uuvodzovky_ignorujuu_zdrojovyy_adresaar;

    struct _cpp_suubor *hlavnyy_suubor;

    /* Akumulaator pre spracovanie vyyrazov. */
    struct op *op_akumulaator, *op_koniec;

    cpp_nastavenia nastavenia;

    int ide_sa_expandovath_makro;
    lokaacia_t invokacshnaa_lokaacia;

    char *daatum;
    char *cshas;

    void *pomoc;
    void *pomoc2;
};

enum typ_include {
    TYP_INCLUDE_INCLUDE,
    TYP_INCLUDE_PRIIKAZOVYY_RIADOK
};

extern unsigned char _cpp_trigrafovaa_mapa[0x100];

/* lex.c */
int _cpp_equiv_tokeny(const cpp_token *t1, const cpp_token *t2);
void _cpp_inic_tokenrad(tokenrad *rad);
void _cpp_cshisti_riadok(cpp_cshii *cshii);
cpp_token *_cpp_lex_token_j(cpp_cshii *cshii);
cpp_token *_cpp_lex_token(cpp_cshii *cshii);
cpp_token *_cpp_docshasnyy_token(cpp_cshii *cshii);
unsigned int _cpp_ostaavajuuce_tokeny_v_neviem2(cpp_neviem2 *neviem2);
const cpp_token *_cpp_token_z_neviem2_na(cpp_neviem2 *neviem2,
                                         unsigned int index);

/* 1.c */
void _cpp_odstraanh_neviem2(cpp_cshii *);
void _cpp_vraath_tokeny_lexeru(cpp_cshii *cshii, unsigned int pocshet);
void _cpp_vraath_tokeny(cpp_cshii *cshii, unsigned int pocshet);

/* makro.c */
int _cpp_definuj_makro(cpp_cshii *cshii, cpp_neviem *neviem);
void _cpp_oddefinuj_makro(cpp_neviem *neviem);

/* direktiivy.c */
void _cpp_inic_direktiivy(cpp_cshii *cshii);
int _cpp_spracuj_direktiivu(cpp_cshii *cshii);
void _cpp_define_vstavanee(cpp_cshii *cshii, const char *);
cpp_ppos *_cpp_pridaj_ppos(cpp_cshii *, unsigned char *, size_t, int od_faazy3);
void _cpp_odstraanh_ppos(cpp_cshii *);
void _cpp_zmenh_suubor(cpp_cshii *, enum cpp_duovody,
                       const char *, unsigned long);

/* suubory.c */
typedef struct _cpp_suubor _cpp_suubor;
_cpp_suubor *_cpp_najdi_suubor(cpp_cshii *cshii, const char *meno,
                               cpp_adresaar *shtart_adr);
int _cpp_suubor_nenajdenyy(_cpp_suubor *suubor);
int _cpp_pridaj_suubor(cpp_cshii *cshii, _cpp_suubor *suubor);
int _cpp_pridaj_include(cpp_cshii *cshii, const char *meno,
                        int shikmee_meno, enum typ_include typ);

/* vyyraz.c */
int _cpp_spracuj_vyyraz(cpp_cshii *cshii, int je_if);
struct op *_cpp_expanduj_op_akumulaator(cpp_cshii *cshii);
