/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"
#include "podpora.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void _cpp_inic_tokenrad(tokenrad *rad)
{
    rad->shtart = malloc(sizeof(cpp_token) * TOKENRAD_DLLZHKA);
    if (rad->shtart == NULL) abort();
    rad->koniec = rad->shtart + TOKENRAD_DLLZHKA;
    rad->predoshlyy = NULL;
    rad->dhalshyy = NULL;
}

static tokenrad *dhalshii_tokenrad(tokenrad *rad)
{
    if (rad->dhalshyy == NULL)
    {
        rad->dhalshyy = malloc(sizeof(tokenrad));
        if (rad->dhalshyy == NULL) abort();
        _cpp_inic_tokenrad(rad->dhalshyy);
        rad->dhalshyy->predoshlyy = rad;
    }

    return (rad->dhalshyy);
}

void _cpp_spracuj_riadkovee_poznaamky(cpp_cshii *cshii)
{
    cpp_ppos *ppos = cshii->ppos;

    for (;;)
    {
        _cpp_riadkovaa_poznaamka *poznaamka = &(ppos
                                                ->poznaamky[
                                                    ppos->akt_poznaamka]);
        
        if (poznaamka->poz > ppos->poz) break;

        ppos->akt_poznaamka++;

        if (poznaamka->typ == '\\' || (poznaamka->typ == ' '))
        {
            if (poznaamka->typ == ' ')
            {
                cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                          "spaetnaa lomka a koniec riadka oddelenee medzerou");
            }

            if (ppos->dhalshii_riadok > (ppos->koniec))
            {
                cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                          "spaetnaa lomka koniec riadka na konci suuboru");
            }

            ppos->zacshiatok_riadka = poznaamka->poz;
            CPP_ZVYYSH_RIADOK(cshii, 0);
        }
        else if (_cpp_trigrafovaa_mapa[poznaamka->typ])
        {
            /* Muozhe tu byth varovanie o trigrafoch, ale nemusii... */
        }
        else
        {
            printf("Nepodporovanyy typ riadkovej poznaamky: %c\n",
                   poznaamka->typ);
            abort();
        }
    }
}

/* Preskocshii Ccshkovyy komentaar. Koniec sa naajde naajdeniim * pred /.
 * Vraathi 1, ak je komentaar ukoncshenyy koncom suuboru, inak vraathi 0.
 *
 * cshii->ppos->poz mieri na * v zacshiatku komentaara. */
int _cpp_preskocsh_blokovyy_komentaar(cpp_cshii *cshii)
{
    cpp_ppos *ppos = cshii->ppos;
    const unsigned char *poz = ppos->poz;
    unsigned char z;

    poz++;
    if (*poz == '/') poz++;

    for (;;)
    {
        z = *(poz++);

        if (z == '/')
        {
            if (poz[-2] == '*')
            {
                break;
            }
        }
        else if (z == '\n')
        {
            ppos->poz = poz - 1;
            _cpp_spracuj_riadkovee_poznaamky(cshii);
            if (ppos->dhalshii_riadok >= ppos->koniec) return (1);
            _cpp_cshisti_riadok(cshii);

            CPP_ZVYYSH_RIADOK(cshii,
                              ppos->dhalshii_riadok - ppos->zacshiatok_riadka);

            poz = ppos->poz;
        }
    }

    ppos->poz = poz;
    _cpp_spracuj_riadkovee_poznaamky(cshii);
    return (0);
}

static void preskocsh_riadkovyy_komentaar(cpp_cshii *cshii)
{
    cpp_ppos *ppos = cshii->ppos;

    while (*(ppos->poz) != '\n') ppos->poz++;
    
    _cpp_spracuj_riadkovee_poznaamky(cshii);
}

static void preskocsh_medzery(cpp_cshii *cshii, unsigned char z)
{
    cpp_ppos *ppos = cshii->ppos;
    int videnyy_nulovyy_znak = 0;

    do {
        if (z == ' ' || z == '\t') ;
        else if (z == '\0') videnyy_nulovyy_znak = 1;
        else if (cshii->stav.v_direktiive)
        {
            cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                      "%s v direktiive",
                      z == '\f' ? "\\f" : "\\v");
        }
        z = *(ppos->poz++);
    } while (JENVPRIESTOR(z));

    if (videnyy_nulovyy_znak)
        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                  "nulovyy znak (nulovee znaky) boli ignorovanee");

    ppos->poz--;
}

static cpp_neviem *cshiitaj_ident(cpp_cshii *cshii,
                                  const unsigned char *shtart)
{
    cpp_neviem *neviem;
    size_t dllzhka;
    const unsigned char *poz = shtart + 1;

    while (JEIDCSHIISLICA(*poz))
    {
        poz++;
    }

    dllzhka = poz - shtart;

    neviem = CPP_NEVIEM(cpp_najdi(cshii, shtart, dllzhka));

    if ((neviem == cshii->shpec_neviem.n___VA_ARGS__)
        && (cshii->stav.va_args_v_poriadku == 0))
    {
        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                  "__VA_ARGS__ sa smie objavith len v expanzii"
                  " variadickeeho makra");
    }

    return (neviem);
}

static void cshiitaj_cshiislo(cpp_cshii *cshii, cpp_rethazec *rethazec)
{
    const unsigned char *shtart, *akt;
    unsigned char *vyysledok;

    shtart = cshii->ppos->poz - 1;

    do {
        akt = cshii->ppos->poz;

        while (JEIDCSHIISLICA(*akt) || *akt == '.'
               || V_PORIADKU_ZNAMIENO(*akt, akt[-1]))
        {
            akt++;
        }

        cshii->ppos->poz = akt;
    } while (0 /*+++DOROB UCN... */);

    rethazec->dllzhka = akt - shtart;
    vyysledok = malloc(rethazec->dllzhka + 1);
    if (vyysledok == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }
    memcpy(vyysledok, shtart, rethazec->dllzhka);
    vyysledok[rethazec->dllzhka] = '\0';
    rethazec->text = vyysledok;
}

static void vytvor_literaal(cpp_cshii *cshii, cpp_token *token,
                            const unsigned char *shtart, unsigned int dllzhka,
                            enum cpp_typtokenu typ)
{
    unsigned char *vyysledok;
    
    vyysledok = malloc(dllzhka + 1);
    if (vyysledok == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }
    memcpy(vyysledok, shtart, dllzhka);
    vyysledok[dllzhka] = '\0';

    token->typ = typ;
    token->hodnota.rethazec.text = vyysledok;
    token->hodnota.rethazec.dllzhka = dllzhka;
}

static void cshiitaj_rethazec(cpp_cshii *cshii, cpp_token *token,
                              const unsigned char *shtart)
{
    enum cpp_typtokenu typ;
    const unsigned char *poz;
    int videnyy_nulovyy_znak = 0;
    unsigned char koncovyy_znak;

    poz = shtart;
    koncovyy_znak = *(poz++);
    if (koncovyy_znak == 'L' || koncovyy_znak == 'U') koncovyy_znak = *(poz++);
    else if (koncovyy_znak == 'u')
    {
        koncovyy_znak = *(poz++);
        if (koncovyy_znak == 'u') koncovyy_znak = *(poz++);
    }

    if (koncovyy_znak == '"')
    {
        typ = (*shtart == 'L' ? CPP_LRETHAZEC :
               (*shtart == 'U' ? CPP_URETHAZEC :
                (*shtart == 'u' ?
                 (shtart[1] == '8' ? CPP_u8RETHAZEC : CPP_uRETHAZEC ) :
                 (CPP_RETHAZEC))));
    }
    else if (koncovyy_znak == '\'')
    {
        typ = (*shtart == 'L' ? CPP_LZNAK :
               (*shtart == 'U' ? CPP_UZNAK :
                (*shtart == 'u' ? CPP_uZNAK :
                 (CPP_ZNAK))));
    }
    else
    {
        koncovyy_znak = '>', typ = CPP_NAAZOV_HLAVICSHKY;
    }

    for (;;)
    {
        unsigned char z = *(poz++);

        if ((z == '\\')
            /* V #include nie suu konce zrushitelhnee. */
            && (cshii->stav.zbieranie_naazvov_hlavicshiek == 0)
            && (*poz != '\n'))
        {
            poz++;
        }
        else if (z == koncovyy_znak) break;
        else if (z == '\n')
        {
            poz--;
            if (koncovyy_znak == '>')
            {
                token->typ = CPP_MENSHIE;
                return;
            }
            typ = CPP_INEE;
            break;
        }
        else if (z == '\0')
        {
            videnyy_nulovyy_znak = 1;
        }
    }

    if (videnyy_nulovyy_znak && (cshii->stav.preskakovanie == 0))
    {
        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                  "nulovyy znak zachovanyy (nulovee znaky zachovanee)"
                  "v literaaly");
    }

    if (typ == CPP_INEE)
    {
        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                  "chyybajuuci koncovyy znak %c\n",
                  (int)koncovyy_znak);
    }

    cshii->ppos->poz = poz;
    vytvor_literaal(cshii, token, shtart, poz - shtart, typ);
}

static void pridaj_riadkovuu_poznaamku(cpp_ppos *ppos,
                                       const unsigned char *poz,
                                       unsigned int typ)
{
    if (ppos->pocshet_poznaamok == ppos->kap_poznaamok)
    {
        ppos->kap_poznaamok = (ppos->kap_poznaamok * 2
                               + 256 /* Naahodnee cshiislo. */);
        ppos->poznaamky = realloc(ppos->poznaamky,
                                  sizeof (*(ppos->poznaamky))
                                  * ppos->kap_poznaamok);
        if (ppos->poznaamky == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }
    }

    ppos->poznaamky[ppos->pocshet_poznaamok].poz = poz;
    ppos->poznaamky[ppos->pocshet_poznaamok].typ = typ;
    ppos->pocshet_poznaamok++;
}

const unsigned char *hlhadaj(const unsigned char *s)
{
    while (!((*s == '\n') || (*s == '\r')
             || (*s == '\\') || (*s == '?')))
    {
        s++;
    }

    return (s);
}

void _cpp_cshisti_riadok(cpp_cshii *cshii)
{
    cpp_ppos *ppos;
    const unsigned char *s;
    unsigned char z, *c, *p;

    ppos = cshii->ppos;
    ppos->akt_poznaamka = ppos->pocshet_poznaamok = 0;
    s = ppos->poz = ppos->zacshiatok_riadka = ppos->dhalshii_riadok;
    ppos->potrebnyy_dhalshii_riadok = 0;

    if (ppos->od_faazy3 == 0)
    {
        const unsigned char *spaetnaalomka = NULL;
        while (1)
        {
            /* Optimalizovanee hlhadanie '\n', '\r', '\\', '?'. */
            s = hlhadaj(s);
            if (*s == '\\')
            {
                spaetnaalomka = s++;
            }
            else if (*s == '?')
            {
                if ((s[1] == '?') && _cpp_trigrafovaa_mapa[s[2]])
                {
                    /* Pridaa poznaamku pre -Vtrigrafy. */
                    pridaj_riadkovuu_poznaamku(ppos, s, s[2]);
                    if (CPP_NASTAVENIE(cshii, trigrafy))
                    {
                        c = (unsigned char *)s;
                        *c = _cpp_trigrafovaa_mapa[s[2]];
                        s += 2;
                        goto pomalaa_cesta;
                    }
                }
                /* Nie je to trigraf. */
                s++;
            }
            else break;
        }

        /* *s je '\r' alebo '\n'. */
        c = (unsigned char *)s;

        if (s == ppos->koniec) goto koniec;

        if ((s[0] == '\r') && (s[1] == '\n'))
        {
            s++;
            if (s == ppos->koniec) goto koniec;
        }

        if (spaetnaalomka == NULL) goto koniec;

        /* Zkontroluje, cshi nie je zrushenyy koniec riadku lomkou. */
        p = c;
        while (JENVPRIESTOR(p[-1])) p--;
        if (p - 1 != spaetnaalomka) goto koniec;

        pridaj_riadkovuu_poznaamku(ppos, p - 1, p == c ? '\\' : ' ');
        c = p - 2;
        ppos->dhalshii_riadok = p - 1;

    pomalaa_cesta:
        while (1)
        {
            z = *(++s);
            *(++c) = z;

            if (z == '\r' || z == '\n')
            {
                if ((z == '\r') && (s != ppos->koniec) && (s[1] == '\n'))
                {
                    s++;
                }
                if (s == ppos->koniec) break;

                /* Zrushenyy koniec riadka? */
                p = c;
                while ((p != ppos->dhalshii_riadok) && JENVPRIESTOR(p[-1])) p--;
                if (p == ppos->dhalshii_riadok || p[-1] != '\\') break;

                pridaj_riadkovuu_poznaamku(ppos, p - 1, p == c ? '\\' : ' ');
                c = p - 2;
                ppos->dhalshii_riadok = p - 1;
            }
            else if (z == '?' && (s[1] == '?') && _cpp_trigrafovaa_mapa[s[2]])
            {
                /* Pridaa poznaamku pre -Vtrigrafy. */
                pridaj_riadkovuu_poznaamku(ppos, s, s[2]);
                if (CPP_NASTAVENIE(cshii, trigrafy))
                {
                    *c = _cpp_trigrafovaa_mapa[s[2]];
                    s += 2;
                }
            }
        }
    }
    else
    {
        while (*s != '\n' && *s != '\r') s++;

        c = (unsigned char *)s;

        if ((s[0] == '\r') && (s != ppos->koniec) && (s[1] == '\n'))
        {
            s++;
        }
    }

koniec:
    *c = '\n';
    /* Straazhna poznaamka, ktoraa sa nemaa spracovath. */
    pridaj_riadkovuu_poznaamku(ppos, c + 1, '\n');
    ppos->dhalshii_riadok = (unsigned char *)s + 1;    
}

/* Vraathi 1, ak bol novyy riadok nacshiitanyy. */
int _cpp_daj_novyy_riadok(cpp_cshii *cshii)
{
    /* Nemuozhe byth dhalshii riadok, kyym sa neskoncshii direktiiva. */
    if(cshii->stav.v_direktiive)
    {
        return (0);
    }

    for (;;)
    {
        cpp_ppos *ppos = cshii->ppos;

        if (ppos->potrebnyy_dhalshii_riadok == 0)
        {
            return (1);
        }
        
        if (ppos->dhalshii_riadok < ppos->koniec)
        {
            _cpp_cshisti_riadok(cshii);
            return (1);
        }

        /* Koniec pposu. */
        /* Ak sa zbierajuu argumenty, nenacshiita sa novyy ppos. */
        if (cshii->stav.zbieranie_argumentov)
        {
            return (0);
        }

        _cpp_odstraanh_ppos(cshii);
        if (cshii->ppos == NULL)
        {
            return (0);
        }
    }
}

#define AK_DHALSHIE_TAK(a1, a2, a3) \
do { \
    vyysledok->typ = a3; \
    if (ppos->poz[0] == a1) \
    { \
        ppos->poz++; \
        vyysledok->typ = a2; \
    } \
} while (0) \

cpp_token *_cpp_lex_token_j(cpp_cshii *cshii)
{
    cpp_token *vyysledok = cshii->akt_token++;
    cpp_ppos *ppos;
    int z;

novyy_riadok:
    vyysledok->vlajky = 0;
    ppos = cshii->ppos;
    if (ppos->potrebnyy_dhalshii_riadok)
    {
        if (_cpp_daj_novyy_riadok(cshii) == 0)
        {
            vyysledok->typ = CPP_KONIEC;

            return (vyysledok);
        }
        if (cshii->drzh_tokeny == 0)
        {
            cshii->akt_tokenrad = &(cshii->zaakladnyy_tokenrad);
            vyysledok = cshii->akt_tokenrad->shtart;
            cshii->akt_token = vyysledok + 1;
        }
        /* vlajky suu pred tyymto bodom v nedefinovanom stave. */
        vyysledok->vlajky = ZACSHIATOK_RIADKA;
        if (cshii->stav.zbieranie_argumentov == 2)
        {
            vyysledok->vlajky |= ZA_MEDZEROU;
        }
    }
    ppos = cshii->ppos;
    
preskocshenyy_komentaar:
    /* Sledovanie poziicie. */
    vyysledok->lokaacia.riadok = cshii->ppos->riadok;
    
preskocshenee_medzery:
    if (ppos->poz >= ppos->poznaamky[ppos->akt_poznaamka].poz)
    {
        _cpp_spracuj_riadkovee_poznaamky(cshii);
        vyysledok->lokaacia.riadok = cshii->ppos->riadok;
    }
    z = *(ppos->poz++);
    if (cshii->nuutenaa_lokaacia.suubor)
    {
        vyysledok->lokaacia = cshii->nuutenaa_lokaacia;
    }
    else
    {
        vyysledok->lokaacia.stllpec = ppos->poz - ppos->zacshiatok_riadka;
        vyysledok->lokaacia.suubor = ppos->meno_suuboru;
    }

    switch (z)
    {
        case ' ': case '\t': case '\f': case '\v': case '\0':
            vyysledok->vlajky |= ZA_MEDZEROU;
            preskocsh_medzery(cshii, z);
            goto preskocshenee_medzery;
        
        case '\n':
            if (ppos->poz < ppos->koniec)
                CPP_ZVYYSH_RIADOK(cshii, 0);
            ppos->potrebnyy_dhalshii_riadok = 1;
            goto novyy_riadok;

        case '0': case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
            vyysledok->typ = CPP_CSHIISLO;
            cshiitaj_cshiislo(cshii, &(vyysledok->hodnota.rethazec));
            break;

        case 'L':
        case 'u':
        case 'U':
            if ((ppos->poz[0] == '\'')
                || (ppos->poz[0] == '"')
                || ((z == 'u')
                    && (ppos->poz[0] == '8')
                    && (ppos->poz[1] == '"')))
            {
                cshiitaj_rethazec(cshii, vyysledok, ppos->poz - 1);
                break;
            }
            /* PREPAD */

        case '_':
        case 'a': case 'b': case 'c': case 'd': case 'e': case 'f': case 'g':
        case 'h': case 'i': case 'j': case 'k': case 'l': case 'm': case 'n':
        case 'o': case 'p': case 'q': case 'r': case 's': case 't':          
        case 'v': case 'w': case 'x': case 'y': case 'z':
        case 'A': case 'B': case 'C': case 'D': case 'E': case 'F': case 'G':
        case 'H': case 'I': case 'J': case 'K':           case 'M': case 'N':
        case 'O': case 'P': case 'Q': case 'R': case 'S': case 'T':          
        case 'V': case 'W': case 'X': case 'Y': case 'Z':
            vyysledok->typ = CPP_IDENT;
            vyysledok->hodnota.neviem = cshiitaj_ident(cshii, ppos->poz - 1);
            ppos->poz += vyysledok->hodnota.neviem->r.dllzhka - 1;
            break;

        case '\'':
        case '"':
            cshiitaj_rethazec(cshii, vyysledok, ppos->poz - 1);
            break;

        case '/':
            if (ppos->poz[0] == '*')
            {
                if (_cpp_preskocsh_blokovyy_komentaar(cshii))
                {
                    cpp_chyba(cshii, CPP_DUU_CHYBA,
                              "neukoncshenyy komentaar");
                }
            }
            else if (ppos->poz[0] == '/')
            {
                /* +++DOROB VAROVANIE PRE C89/90. */
                preskocsh_riadkovyy_komentaar(cshii);
            }
            else if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_LOMKA_ROVNAA_SA;
                break;
            }
            else
            {
                vyysledok->typ = CPP_LOMKA;
                break;
            }

            if (1)
            {
                vyysledok->vlajky |= ZA_MEDZEROU;
                goto preskocshenyy_komentaar;
            }

            break;

        case '<':
            if (cshii->stav.zbieranie_naazvov_hlavicshiek)
            {
                cshiitaj_rethazec(cshii, vyysledok, ppos->poz - 1);
                if (vyysledok->typ != CPP_MENSHIE) break;
            }

            vyysledok->typ = CPP_MENSHIE;
            if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_MENSHIE_ROVNAA_SA;
            }
            else if (ppos->poz[0] == '<')
            {
                ppos->poz++;
                AK_DHALSHIE_TAK('=', CPP_LH_POSUN_ROVNAA_SA, CPP_LH_POSUN);
            }
            else
            {
                if (ppos->poz[0] == ':')
                {
                    ppos->poz++;
                    vyysledok->vlajky |= DIGRAF;
                    vyysledok->typ = CPP_LH_HZAATVORKA;
                }
                else if (ppos->poz[0] == '%')
                {
                    ppos->poz++;
                    vyysledok->vlajky |= DIGRAF;
                    vyysledok->typ = CPP_LH_KZAATVORKA;
                }
            }
            break;

        case '>':
            vyysledok->typ = CPP_VAECSHIE;
            if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_VAECSHIE_ROVNAA_SA;
            }
            else if (ppos->poz[0] == '>')
            {
                ppos->poz++;
                AK_DHALSHIE_TAK('=', CPP_P_POSUN_ROVNAA_SA, CPP_P_POSUN);
            }
            break;

        case '%':
            vyysledok->typ = CPP_MODULO;
            if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_MODULO_ROVNAA_SA;
            }
            else
            {
                if (ppos->poz[0] == ':')
                {
                    ppos->poz++;
                    vyysledok->vlajky |= DIGRAF;
                    vyysledok->typ = CPP_MREZHA;
                    if (ppos->poz[0] == '%' && ppos->poz[1] == ':')
                    {
                        ppos->poz += 2, vyysledok->typ = CPP_ZLEP;
                    }
                }
                else if (ppos->poz[0] == '>')
                {
                    ppos->poz++;
                    vyysledok->vlajky |= DIGRAF;
                    vyysledok->typ = CPP_P_KZAATVORKA;
                }
            }
            break;

        case '.':
            vyysledok->typ = CPP_BODKA;
            if (JECSHIISLICA(ppos->poz[1]))
            {
                vyysledok->typ = CPP_CSHIISLO;
                cshiitaj_cshiislo(cshii, &(vyysledok->hodnota.rethazec));
            }
            else if (ppos->poz[0] == '.' && ppos->poz[1] == '.')
            {
                ppos->poz += 2, vyysledok->typ = CPP_ELIPSA;
            }
            break;

        case '+':
            vyysledok->typ = CPP_PLUS;
            if (ppos->poz[0] == '+')
            {
                ppos->poz++, vyysledok->typ = CPP_PLUS_PLUS;
            }
            else if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_PLUS_ROVNAA_SA;
            }
            break;

        case '-':
            vyysledok->typ = CPP_MIINUS;
            if (ppos->poz[0] == '>')
            {
                ppos->poz++, vyysledok->typ = CPP_DEREF;
            }
            else if (ppos->poz[0] == '-')
            {
                ppos->poz++, vyysledok->typ = CPP_MIINUS_MIINUS;
            }
            else if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_MIINUS_ROVNAA_SA;
            }
            break;

        case '&':
            vyysledok->typ = CPP_A;
            if (ppos->poz[0] == '&')
            {
                ppos->poz++, vyysledok->typ = CPP_A_A;
            }
            else if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_A_ROVNAA_SA;
            }
            break;

        case '|':
            vyysledok->typ = CPP_ALEBO;
            if (ppos->poz[0] == '|')
            {
                ppos->poz++, vyysledok->typ = CPP_ALEBO_ALEBO;
            }
            else if (ppos->poz[0] == '=')
            {
                ppos->poz++, vyysledok->typ = CPP_ALEBO_ROVNAA_SA;
            }
            break;

        case ':':
            vyysledok->typ = CPP_DVOJBODKA;
            if (ppos->poz[0] == '>')
            {
                ppos->poz++;
                vyysledok->vlajky |= DIGRAF;
                vyysledok->typ = CPP_P_HZAATVORKA;
            }
            break;

        case '*':
            AK_DHALSHIE_TAK('=', CPP_HVIEZDA_ROVNAA_SA, CPP_HVIEZDA); break;
        case '=':
            AK_DHALSHIE_TAK('=', CPP_ROVNAA_SA_ROVNAA_SA, CPP_ROVNAA_SA); break;
        case '!':
            AK_DHALSHIE_TAK('=', CPP_NIE_ROVNAA_SA, CPP_NIE); break;
        case '^':
            AK_DHALSHIE_TAK('=', CPP_XALEBO_ROVNAA_SA, CPP_XALEBO); break;
        case '#':
            AK_DHALSHIE_TAK('#', CPP_ZLEP, CPP_MREZHA); break;

        case '~': vyysledok->typ = CPP_KOMPLEMENT; break;
        case '?': vyysledok->typ = CPP_OTAAZNIK; break;
        case ',': vyysledok->typ = CPP_CSHIARKA; break;
        case '(': vyysledok->typ = CPP_LH_ZAATVORKA; break;
        case ')': vyysledok->typ = CPP_P_ZAATVORKA; break;
        case '[': vyysledok->typ = CPP_LH_HZAATVORKA; break;
        case ']': vyysledok->typ = CPP_P_HZAATVORKA; break;
        case '{': vyysledok->typ = CPP_LH_KZAATVORKA; break;
        case '}': vyysledok->typ = CPP_P_KZAATVORKA; break;
        case ';': vyysledok->typ = CPP_BODKOCSHIARKA; break;

        case '@': vyysledok->typ = CPP_ZAVINAACSH; break;

        default:
            vytvor_literaal(cshii, vyysledok, ppos->poz - 1, 1, CPP_INEE);
            break;
    }

    return (vyysledok);
}

cpp_token *_cpp_lex_token(cpp_cshii *cshii)
{
    cpp_token *vyysledok;

    for (;;)
    {
        if (cshii->akt_token == cshii->akt_tokenrad->koniec)
        {
            cshii->akt_tokenrad = dhalshii_tokenrad(cshii->akt_tokenrad);
            cshii->akt_token = cshii->akt_tokenrad->shtart;
        }
        
        if (cshii->tokeny_vpredu)
        {
            cshii->tokeny_vpredu--;
            vyysledok = cshii->akt_token++;
        }
        else vyysledok = _cpp_lex_token_j(cshii);
        
        if (vyysledok->vlajky & ZACSHIATOK_RIADKA)
        {
            if (vyysledok->typ == CPP_MREZHA
                /* Ak je zbieranie agrumentov 1, zbiera sa prvaa zaatvorka,
                 * to znamenaa, zhe tento token sa vraati spaeth. */
                && cshii->stav.zbieranie_argumentov != 1)
            {
                if (_cpp_spracuj_direktiivu(cshii) == 0)
                {
                    if (cshii->vyysledok_direktiivy.typ == CPP_NICSH)
                        continue;
                    vyysledok = &(cshii->vyysledok_direktiivy);
                }
            }

            if (cshii->spaetneevolania.zmena_riadka
                && !(cshii->stav.preskakovanie))
            {
                cshii->spaetneevolania.zmena_riadka(cshii,
                                                    vyysledok,
                                                    (cshii
                                                     ->stav
                                                     .zbieranie_argumentov));
            }
        }

        /* V direktiivach sa nepreskakujuu tokeny. */
        if (cshii->stav.v_direktiive) break;

        if (!(cshii->stav.preskakovanie) || (vyysledok->typ == CPP_KONIEC))
            break;
    }

    return (vyysledok);
}

const cpp_token *cpp_pozri_token(cpp_cshii *cshii, unsigned int index)
{
    cpp_neviem2 *neviem2 = cshii->neviem2;
    const cpp_token *token;
    unsigned int pocshet;
    void (*zmena_riadka)(cpp_cshii *, const cpp_token *, int);

    while (neviem2)
    {
        unsigned int p = _cpp_ostaavajuuce_tokeny_v_neviem2(neviem2);

        if (index < p) return (_cpp_token_z_neviem2_na(neviem2, index));

        index -= p;
        neviem2 = neviem2->dhalshie;
    }

    /* Musia sa precshiitath dalshie tokeny bez znicshenia staryych. */
    pocshet = index;
    cshii->drzh_tokeny++;

    /* Pre pozretee tokeny sa docshasne vypne zmena_riadka,
     * kyym sa neprecshiitajuu skutocshne. */
    zmena_riadka = cshii->spaetneevolania.zmena_riadka;
    cshii->spaetneevolania.zmena_riadka = NULL;

    do {
        token = _cpp_lex_token(cshii);
        if (token->typ == CPP_KONIEC)
        {
            index--;
            break;
        }
    } while (index--);

    _cpp_vraath_tokeny_lexeru(cshii, pocshet - index);
    cshii->spaetneevolania.zmena_riadka = zmena_riadka;
    cshii->drzh_tokeny--;

    return (token);
}

cpp_token *_cpp_docshasnyy_token(cpp_cshii *cshii)
{
    cpp_token *novyy, *staryy;

    /* _cpp_lex_token() nikdy nenechaa
     * cshii->akt_token == cshii->akt_tokenrad->shtart.*/
    staryy = cshii->akt_token - 1;

    if (cshii->tokeny_vpredu)
    {
        unsigned int tokeny_vpredu = cshii->tokeny_vpredu;
        tokenrad *rad = cshii->akt_tokenrad;

        printf("+++OTESTUJ _cpp_docshasnyy_token\n");

        if (tokeny_vpredu < rad->koniec - cshii->akt_token)
        {
            memmove(cshii->akt_token + 1, cshii->akt_token,
                    sizeof(cpp_token) * tokeny_vpredu);
        }
        else
        {
            tokeny_vpredu -= rad->koniec - cshii->akt_token;

            while (1)
            {
                rad = dhalshii_tokenrad(rad);
                if (rad->koniec - rad->shtart > tokeny_vpredu)
                {
                    break;
                }
                tokeny_vpredu -= rad->koniec - rad->shtart;
            }

            memmove(rad->shtart + 1, rad->shtart,
                    sizeof(cpp_token) * tokeny_vpredu);
            while (1)
            {
                rad->shtart[0] = rad->predoshlyy->koniec[-1];
                rad = rad->predoshlyy;
                if (rad == cshii->akt_tokenrad) break;
                memmove(rad->shtart + 1, rad->shtart,
                        sizeof(cpp_token) * (rad->koniec - rad->shtart - 1));
            }

            if (cshii->akt_token + 1 < rad->koniec)
            {
                memmove(cshii->akt_token + 1, cshii->akt_token,
                        sizeof(cpp_token)
                        * (rad->koniec - cshii->akt_token - 1));
            }
        }
    }
    
    if (cshii->akt_token == cshii->akt_tokenrad->koniec)
    {
        cshii->akt_tokenrad = dhalshii_tokenrad(cshii->akt_tokenrad);
        cshii->akt_token = cshii->akt_tokenrad->shtart;
    }

    novyy = cshii->akt_token++;
    novyy->lokaacia = staryy->lokaacia;

    return (novyy);
}

unsigned int _cpp_ostaavajuuce_tokeny_v_neviem2(cpp_neviem2 *neviem2)
{
    switch (neviem2->typ_tokenov)
    {
        case TOKENY_TYP_PRIAME: return (neviem2->poslednyy.token
                                        - neviem2->prvyy.token);
        case TOKENY_TYP_NEPRIAME: return (neviem2->poslednyy.stoken
                                          - neviem2->prvyy.stoken);
    }

    printf("Internaa chyba _cpp_ostaavajuuce_tokeny_v_neviem2\n");
    abort();
}

const cpp_token *_cpp_token_z_neviem2_na(cpp_neviem2 *neviem2,
                                         unsigned int index)
{
    switch (neviem2->typ_tokenov)
    {
        case TOKENY_TYP_PRIAME: return (&(neviem2->prvyy.token[index]));
        case TOKENY_TYP_NEPRIAME: return (neviem2->prvyy.stoken[index]);
    }

    printf("Internaa chyba _cpp_token_z_neviem2_na\n");
    abort();
}

void cpp_vynucuj_lokaaciu_tokenov(cpp_cshii *cshii, lokaacia_t lok)
{
    cshii->nuutenaa_lokaacia = lok;
}

void cpp_prestanh_vynucovath_lokaaciu_tokenov(cpp_cshii *cshii)
{
    cshii->nuutenaa_lokaacia.suubor = NULL;
}
