/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static cpp_makro *novee_makro(void)
{
    cpp_makro *makro = malloc(sizeof(*makro));

    if (makro == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    makro->parametre = 0;
    makro->pocshet = 0;
    makro->pocshet_parametrov = 0;
    makro->funkciovee = 0;
    makro->variadickee = 0;
    makro->tokeny_naviac = 0;

    return (makro);
}

typedef struct {
    cpp_neviem *neviem;
    int typ;
    union _cpp_neviem_hodnota hodnota;
} makro_parameter_ulozhenee_daata;

int _cpp_ulozh_parameter(cpp_cshii *cshii, int pocshet_parametrov,
                         cpp_neviem *neviem, cpp_neviem ***parametre)
{
    unsigned int velhkosth;
    
    if (neviem->typ == NEVIEM_MAKRO_PARAMETER)
    {
        cpp_chyba(cshii, CPP_DUU_CHYBA,
                  "duplicitnyy makro parameter \"%s\"",
                  NEVIEM_MENO(neviem));
        return (1);
    }

    velhkosth = (sizeof(makro_parameter_ulozhenee_daata)
                * (pocshet_parametrov + 1));
    if (velhkosth > cshii->makro_pamaeth_velhkosth)
    {
        cshii->makro_pamaeth = realloc(cshii->makro_pamaeth, velhkosth);
        if (cshii->makro_pamaeth == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }

        cshii->makro_pamaeth_velhkosth = velhkosth;
    }

    {
        makro_parameter_ulozhenee_daata *daata = ((void *)
                                                  (cshii->makro_pamaeth));

        daata += pocshet_parametrov;

        daata->neviem = neviem;
        daata->typ = neviem->typ;
        daata->hodnota = neviem->hodnota;
    }

    *parametre = realloc(*parametre,
                         sizeof (**parametre) * (pocshet_parametrov + 1));
    if (*parametre == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    (*parametre)[pocshet_parametrov] = neviem;

    neviem->typ = NEVIEM_MAKRO_PARAMETER;
    neviem->hodnota.index_parametru = pocshet_parametrov;
    
    return (0);
}

void _cpp_odulozh_parametre(cpp_cshii *cshii, int pocshet_parametrov)
{
    while (pocshet_parametrov--)
    {
        cpp_neviem *neviem;
        makro_parameter_ulozhenee_daata *daata = ((void *)
                                                  (cshii->makro_pamaeth));

        daata += pocshet_parametrov;

        neviem = daata->neviem;
        neviem->typ = daata->typ;
        neviem->hodnota = daata->hodnota;
    }
}

static int zozbieraj_parametre(cpp_cshii *cshii, int *pocshet_parametrov,
                               int *variadickee, cpp_neviem ***parametre)
{
    int za_ident = 0;
    
    *pocshet_parametrov = 0;
    *variadickee = 0;

    *parametre = NULL;
    
    for (;;)
    {
        const cpp_token *token = _cpp_lex_token(cshii);

        switch (token->typ)
        {
            case CPP_IDENT: {
                if (za_ident || *variadickee) goto zle;
                za_ident = 1;
                if (_cpp_ulozh_parameter(cshii, *pocshet_parametrov,
                                         token->hodnota.neviem, parametre))
                {
                    return (1);
                }
                (*pocshet_parametrov)++;
                break;
            }

            case CPP_CSHIARKA: {
                if (!za_ident || *variadickee) goto zle;
                za_ident = 0;
                break;
            }

            case CPP_ELIPSA: {
                if (*variadickee) goto zle;
                if (za_ident)
                {
                    cpp_chyba(cshii, CPP_DUU_CHYBA,
                              "pomenovanee variadickee"
                              " makraa nie suu povolenee");
                    return (1);
                }
                if (_cpp_ulozh_parameter(cshii, *pocshet_parametrov,
                                         cshii->shpec_neviem.n___VA_ARGS__,
                                         parametre))
                {
                    return (1);
                }
                (*pocshet_parametrov)++;
                *variadickee = 1;
                cshii->stav.va_args_v_poriadku = 1;
                break;
            }

            case CPP_P_ZAATVORKA: {
                if (za_ident || !*pocshet_parametrov || *variadickee)
                {
                    return (0);
                }
                goto zle;
            }

            default:
            zle: {
                const char *spraavy[] = {
                    "ocshakaavanyy naazov parametra, naajdenee \"%s\"",
                    "ocshakaavanee ',' alebo ')' parametra, naajdenee \"%s\"",
                     "ocshakaavanyy naazov parametra pred koncom riadka",
                     "ocshakaavanaa ')' pred koncom riadka",
                     "ocshakaavanaa ')' za \"...\""};
                int i = za_ident;
                const unsigned char *ako_text = NULL;
                if (*variadickee) i = 4;
                else if (token->typ == CPP_KONIEC) i += 2;
                else ako_text = cpp_token_ako_text(token);

                cpp_chyba(cshii, CPP_DUU_CHYBA, spraavy[i], ako_text);
                return (1);
            }
        }
    }
}

static cpp_makro *makro_pridaj_token(cpp_cshii *cshii, cpp_makro *makro)
{
    cpp_token *token;

    makro = realloc(makro,
                    sizeof(*makro) + sizeof(cpp_token) * (makro->pocshet));
    if (makro == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }
    
    {
        cpp_token *ulozhenyy_akt_token = cshii->akt_token;

        cshii->akt_token = &(makro->tokeny[makro->pocshet]);
        token = _cpp_lex_token(cshii);

        cshii->akt_token = ulozhenyy_akt_token;
    }

    if (token->typ == CPP_IDENT
        && token->hodnota.neviem->typ == NEVIEM_MAKRO_PARAMETER)
    {
        cpp_neviem *neviem = token->hodnota.neviem;
        token->typ = CPP_MAKRO_ARGUMENT;
        token->hodnota.makro_argument.cshiislo = (token->hodnota.neviem
                                                   ->hodnota.index_parametru);
        token->hodnota.makro_argument.piisanie = neviem;
    }

    return (makro);
}

static cpp_makro *vytvor_definiiciu(cpp_cshii *cshii)
{
    cpp_makro *makro = NULL;
    cpp_token prvyy;
    cpp_token *token;

    cpp_neviem **parametre;
    int pocshet_parametrov = 0;
    int variadickee = 0;

    int dobre = 0;
    int za_zlepeniim = 0;
    unsigned int tokeny_naviac = 0;

    {
        cpp_token *ulozhenyy_akt_token = cshii->akt_token;

        cshii->akt_token = &prvyy;
        token = _cpp_lex_token(cshii);

        cshii->akt_token = ulozhenyy_akt_token;
    }

    if (token->vlajky & ZA_MEDZEROU) /* Objektovee makro. */;
    else if (token->typ == CPP_LH_ZAATVORKA)
    {
        if (zozbieraj_parametre(cshii, &pocshet_parametrov, &variadickee,
                                &parametre))
        {
            goto koniec;
        }

        token = NULL;
    }
    else if (token->typ != CPP_KONIEC)
    {
        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                  "ISO C17 vyzhaduje medzeru za naazvom objektoveeho makra");
    }

    makro = novee_makro();

    if (token == NULL)
    {
        makro->pocshet_parametrov = pocshet_parametrov;
        makro->variadickee = variadickee;
        makro->parametre = parametre;
        makro->funkciovee = 1;
    }
    else
    {
        makro->tokeny[0] = *token;
        token = &(makro->tokeny[0]);
        makro->pocshet = 1;
    }

    for (;; token = NULL)
    {
        if (token == NULL)
        {
            makro = makro_pridaj_token(cshii, makro);
            token = &(makro->tokeny[makro->pocshet++]);
        }

        if (makro->pocshet > 1 && (token[-1].typ == CPP_MREZHA)
            && makro->funkciovee)
        {
            if (token->typ == CPP_MAKRO_ARGUMENT)
            {
                if (token->vlajky & ZA_MEDZEROU)
                {
                    token->vlajky |= ZZ_ZA_MEDZEROU;
                }
                if (token[-1].vlajky & DIGRAF)
                {
                    token->vlajky |= ZZ_DIGRAF;
                }
                token->vlajky &= ~ZA_MEDZEROU;
                token->vlajky |= ZRETHAZCUJ_ARGUMENT;
                token->vlajky |= token[-1].vlajky & ZA_MEDZEROU;
                token[-1] = token[0];
                makro->pocshet--;
            }
            else
            {
                /* C17 6.10.3.2 V funkciovom makre #
                 * musii byth nasledovanee parametrom. */
                cpp_chyba(cshii, CPP_DUU_CHYBA,
                          "'#' nie je nasledovanee makro parametrom");
                goto koniec;
            }
        }
        
        if (token->typ == CPP_KONIEC)
        {
            if (za_zlepeniim)
            {
                /* C17 6.10.3.3 ## nesmie byth na konci tokenov. */
                cpp_chyba(cshii, CPP_DUU_CHYBA,
                          "'##' nesmie byth na konci makra");
                goto koniec;
            }
            break;
        }

        if (token->typ == CPP_ZLEP)
        {
            if (makro->pocshet == 1)
            {
                /* C17 6.10.3.3 ## nesmie byth na zacshiatku tokenov. */
                cpp_chyba(cshii, CPP_DUU_CHYBA,
                          "'##' nesmie byth na zacshiatku makra");
                goto koniec;
            }

            if (za_zlepeniim)
            {
                /* Za sebou nasledujuuce CPP_ZLEP.
                 * Tento sa presunie na koniec. */
                tokeny_naviac++;
                token->hodnota.cshiislo_tokenu = makro->pocshet - 1;
            }
            else
            {
                /* Zahodii sa ## operaator. */
                makro->pocshet--;
                token[-1].vlajky |= ZLEP_LHAVO;
                if (token->vlajky & ZA_MEDZEROU)
                    token[-1].vlajky |= ZZ_ZA_MEDZEROU;
                if (token->vlajky & DIGRAF)
                    token[-1].vlajky |= ZZ_DIGRAF;
            }

            za_zlepeniim = 1;
        }
        else za_zlepeniim = 0;
    }

    dobre = 1;

    /* CPP_KONIEC sa nezaraata. */
    makro->pocshet--;

    if (makro->pocshet)
    {
        /* Medzery pred prvyym token zoznamu nahradenia sa ignorujuu. */
        makro->tokeny[0].vlajky &= ~ZA_MEDZEROU;
    }

    if (tokeny_naviac)
    {
        /* Umiestni po sebe nasledujuuce ## na koniec tokenov za sebou. */
        cpp_token *docshasnee = malloc(sizeof(cpp_token) * tokeny_naviac);
        unsigned int norm_index = 0, navyshe_index = 0;
        unsigned int index;

        if (docshasnee == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }

        for (index = 0; index < makro->pocshet; index++)
        {
            if (makro->tokeny[index].typ == CPP_ZLEP)
                docshasnee[navyshe_index++] = makro->tokeny[index];
            else
                makro->tokeny[norm_index++] = makro->tokeny[index];
        }

        memcpy(&(makro->tokeny[norm_index]), docshasnee,
               sizeof(cpp_token) * tokeny_naviac);

        free(docshasnee);
        
        makro->tokeny_naviac = 1;
    }

koniec:
    cshii->stav.va_args_v_poriadku = 0;
    if (dobre == 0 && makro)
    {
        printf("+++ZNICSHENIE MAKRA\n");
        makro = NULL;
    }
    
    _cpp_odulozh_parametre(cshii, pocshet_parametrov);

    return (makro);
}

int varuj_o_redefiniici(cpp_cshii *cshii, cpp_neviem *neviem,
                        const cpp_makro *makro2)
{
    unsigned int i;
    cpp_makro *makro1 = neviem->hodnota.makro;

    /* +++Varovanie o redefiniicii vstavaneeho makra. */

    /* Redefiniicia makra je povolenaa len ak je rovnakaa ako staraa definiicia. */
    
    if ((makro1->pocshet_parametrov != makro2->pocshet_parametrov)
        || (makro1->funkciovee != makro2->funkciovee)
        || (makro1->variadickee != makro2->variadickee))
        return (1);

    for (i = makro1->pocshet_parametrov; i--; )
    {
        if (makro1->parametre[i] != makro2->parametre[i])
            return (1);
    }

    if (makro1->pocshet != makro2->pocshet) return (1);

    for (i = makro1->pocshet; i--; )
    {
        if (!_cpp_equiv_tokeny(&(makro1->tokeny[i]), &(makro2->tokeny[i])))
            return (1);
    }

    return (0);
}

int _cpp_definuj_makro(cpp_cshii *cshii, cpp_neviem *neviem)
{
    cpp_makro *makro;

    makro = vytvor_definiiciu(cshii);

    if (makro == NULL) return (1);

    if (cpp_makro_s(neviem))
    {
        if (varuj_o_redefiniici(cshii, neviem, makro))
        {
            cpp_chyba(cshii, CPP_DUU_CHYBA,
                      "\"%s\" redefinovanee", NEVIEM_MENO(neviem));
        }

        _cpp_oddefinuj_makro(neviem);
    }

    neviem->typ = NEVIEM_MAKRO;
    neviem->hodnota.makro = makro;

    return (0);
}

void _cpp_oddefinuj_makro(cpp_neviem *neviem)
{
    neviem->typ = NEVIEM_NICSH;
    neviem->vlajky &= ~NEVIEM_VYPNUTEE;

    printf("+++Uvolhni makro\n");
}
