/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"
#include "naazvysuuborov.h"
#include "podpora.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct _cpp_suubor {
    char *meno;
    FILE *f;
    cpp_adresaar *adresaar;
    char *cesta;

    char *meno_adresaaru;

    int nenajdenyy;
};

/* Rethaz pre <> je cshasthou rethaze "", inak sa nastavii rethaz "". */
void cpp_nastav_include_rethaze(cpp_cshii *cshii,
                                cpp_adresaar *uuvodzovky,
                                cpp_adresaar *shikmee,
                                int uuvodzovky_ignorujuu_zdrojovyy_adresaar)
{
    cshii->uuvodzovkovee_include = uuvodzovky;
    cshii->shikmee_include = uuvodzovky;
    (cshii->
     uuvodzovky_ignorujuu_zdrojovyy_adresaar =
     uuvodzovky_ignorujuu_zdrojovyy_adresaar);

    for (; uuvodzovky; uuvodzovky = uuvodzovky->dhalshii)
    {
        if (uuvodzovky == shikmee)
        {
            cshii->shikmee_include = shikmee;
        }
    }
}

static char *naazov_adresaaru_suuboru(_cpp_suubor *suubor)
{
    if (suubor->meno_adresaaru == NULL)
    {
        size_t dllzhka = meno_suuboru(suubor->cesta) - (suubor->cesta);
        char *meno = malloc(dllzhka + 1);
        if (meno == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }
        memcpy(meno, suubor->cesta, dllzhka);
        meno[dllzhka] = '\0';
        suubor->meno_adresaaru = meno;
    }

    return (suubor->meno_adresaaru);
}

static cpp_adresaar *vytvor_cpp_adresaar(cpp_cshii *cshii,
                                         const char *meno)
{
    cpp_adresaar *adr = malloc(sizeof(*adr));
    if (adr == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    adr->dhalshii = cshii->uuvodzovkovee_include;
    {
        size_t dllzhka = strlen(meno);
        adr->meno = malloc(dllzhka + 1);
        if (adr->meno == NULL)
        {
            printf("Chyba pri alokaacii\n");
            abort();
        }
        memcpy(adr->meno, meno, dllzhka + 1);
    }

    return (adr);
}

static cpp_adresaar *najdi_shtart_cesty(cpp_cshii *cshii,
                                        const char *meno,
                                        int shikmee,
                                        enum typ_include typ)
{
    cpp_adresaar *adr;
    _cpp_suubor *suubor;

    if (JE_ABSOLUUTNA_CESTA(meno))
        return (&(cshii->zhiadna_hlhadacia_cesta));

    suubor = cshii->ppos == NULL ? cshii->hlavnyy_suubor : cshii->ppos->suubor;

    if (shikmee) adr = cshii->shikmee_include;
    else if (typ == TYP_INCLUDE_PRIIKAZOVYY_RIADOK)
        return(vytvor_cpp_adresaar(cshii, "./"));
    else if (cshii->uuvodzovky_ignorujuu_zdrojovyy_adresaar)
        adr = cshii->uuvodzovkovee_include;
    else
        return(vytvor_cpp_adresaar(cshii, naazov_adresaaru_suuboru(suubor)));

    if (adr == NULL)
    {
        cpp_chyba(cshii, CPP_DUU_CHYBA,
                  "zhiadna include cesta na naajdenie %s", meno);
    }

    return (adr);
}

int _cpp_pridaj_include(cpp_cshii *cshii, const char *meno,
                        int shikmee_meno, enum typ_include typ)
{
    cpp_adresaar *adr;
    _cpp_suubor *suubor;

    adr = najdi_shtart_cesty(cshii, meno, shikmee_meno, typ);
    if (adr == NULL) return (1);

    suubor = _cpp_najdi_suubor(cshii, meno, adr);
    
    return (_cpp_pridaj_suubor(cshii, suubor));
}

static void otvorenie_suuboru_zlyhanie(cpp_cshii *cshii, _cpp_suubor *suubor)
{
    cpp_chyba(cshii, CPP_DUU_ZLYHANIE, "Nenashiel sa suubor: %s",
              suubor->cesta ? suubor->cesta : suubor->meno);
}

static int cshiitaj_suubor(cpp_cshii *cshii, _cpp_suubor *suubor)
{
    FILE *f;
    unsigned char *pamaeth;
    size_t velhkosth = 8 * 1024;
    size_t precshiitanee = 0;
    size_t zmena;

    if (suubor->f == NULL)
    {
        otvorenie_suuboru_zlyhanie(cshii, suubor);
        return (1);
    }
    f = suubor->f;

    pamaeth = malloc(velhkosth + 16);
    if (pamaeth == NULL)
    {
        fclose(f);
        return (1);
    }

    while ((zmena = fread(pamaeth + precshiitanee,
                          1, velhkosth - precshiitanee, f)) > 0)
    {
        precshiitanee += zmena;

        if (precshiitanee == velhkosth)
        {
            void *staryy = pamaeth;
            velhkosth *= 2;

            if ((pamaeth = realloc(pamaeth, velhkosth + 16)) == NULL)
            {
                free(staryy);
                fclose(f);
                return (1);
            }
        }
    }

    fclose(f);
    suubor->f = NULL;

    pamaeth[precshiitanee] = '\n';

    _cpp_pridaj_ppos(cshii, pamaeth, precshiitanee, 0);
    cshii->ppos->suubor = suubor;
    /* Sledovanie poziicie. */
    cshii->ppos->meno_suuboru = suubor->meno;
    cshii->ppos->riadok = 1;

    _cpp_zmenh_suubor(cshii, CPP_D_VSTUP,
                      cshii->ppos->meno_suuboru,
                      cshii->ppos->riadok);

    return (0);
}

int _cpp_pridaj_suubor(cpp_cshii *cshii, _cpp_suubor *suubor)
{
    return (cshiitaj_suubor(cshii, suubor));
}

static _cpp_suubor *vytvor_cpp_suubor(cpp_cshii *cshii,
                                      cpp_adresaar *adresaar,
                                      const char *meno)
{
    _cpp_suubor *suubor = malloc(sizeof(*suubor));

    if (suubor == NULL)
    {
        printf("Cbyha pri alokaacii\n");
        abort();
    }

    suubor->f = NULL;
    suubor->adresaar = adresaar;
    suubor->meno = malloc(strlen((const char *)meno) + 1);
    if (suubor->meno == NULL)
    {
        printf("Cbyha pri alokaacii\n");
        abort();
    }
    strcpy((char *)(suubor->meno), (const char *)meno);

    suubor->meno_adresaaru = NULL;

    suubor->nenajdenyy = 1;

    return (suubor);
}

static char *pridaj_suubor_k_adresaaru(_cpp_suubor *suubor,
                                       cpp_adresaar *adr)
{
    size_t sdll, adll;
    char *cesta;

    sdll = strlen(suubor->meno);
    adll = strlen(adr->meno);

    cesta = malloc(adll + 1 + sdll + 1);
    if (cesta == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    memcpy(cesta, adr->meno, adll);
#define JE_CESTNYY_ODDELOVACSH(a) ((a == '\\') || (a == '/'))
    if (adll && !JE_CESTNYY_ODDELOVACSH(cesta[adll - 1]))
        cesta[adll++] = '/';
    memcpy(&(cesta[adll]), suubor->meno, sdll + 1);

    return (cesta);
}

static int najdenyy_suubor_v_adresaari(cpp_cshii *cshii, _cpp_suubor *suubor)
{
    char *cesta;

    cesta = pridaj_suubor_k_adresaaru(suubor, suubor->adresaar);

    if (cesta)
    {
        suubor->cesta = cesta;
        if ((suubor->f = fopen((char *)(suubor->cesta), "rb")))
        {
            suubor->nenajdenyy = 0;
            return (1);
        }

        suubor->cesta = suubor->meno;
        free(cesta);
    }
    else
    {
        suubor->cesta = NULL;
    }
    
    return (0);
}

_cpp_suubor *_cpp_najdi_suubor(cpp_cshii *cshii, const char *meno,
                               cpp_adresaar *shtart_adr)
{
    _cpp_suubor *suubor;

    suubor = vytvor_cpp_suubor(cshii, shtart_adr, meno);
    for (;;)
    {
        if (najdenyy_suubor_v_adresaari(cshii, suubor)) break;

        suubor->adresaar = suubor->adresaar->dhalshii;
        if (suubor->adresaar == NULL)
        {
            return (suubor);
        }
    }
    
    return (suubor);
}

int _cpp_suubor_nenajdenyy(_cpp_suubor *suubor)
{
    return (suubor->nenajdenyy);
}
