/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "tabsym.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

tabsym *tabsym_vytvor_tabsym(int velhkosth, tabsym_r *(*alokuj_r)(void))
{
    tabsym *tab = malloc(sizeof(*tab));
    int i;

    if (tab == NULL) return (NULL);

    tab->velhkosth = velhkosth;
    tab->alokuj_r = alokuj_r;
    tab->riadky = malloc(sizeof(*(tab->riadky)) * velhkosth);

    if (tab->riadky == NULL)
    {
        free(tab);
        return (NULL);
    }

    for (i = 0; i < velhkosth; i++)
    {
        tab->riadky[i] = NULL;
    }

    return (tab);
}

tabsym_r *tabsym_najdi(tabsym *tab, const unsigned char *meno, int dllzhka)
{
    int hcsh = 0;
    int i;
    tabsym_r *r, **r_pred;

    for (i = 0; i < dllzhka; i++)
    {
        hcsh = (hcsh * 43) + (meno[i] - 87);
    }
    if (hcsh < 0) hcsh = -hcsh;

    r = tab->riadky[hcsh % (tab->velhkosth)];
    r_pred = &(tab->riadky[hcsh % (tab->velhkosth)]);
    for (; r; r_pred = &(r->dhalshii), r = r->dhalshii)
    {
        if ((r->dllzhka == dllzhka) && (memcmp(r->meno, meno, dllzhka) == 0))
        {
            return (r);
        }
    }

    r = tab->alokuj_r();
    if (r == NULL)
    {
        printf("Chyba pri alokaacii\n");
        exit(1);
    }

    r->meno = malloc(dllzhka + 1);
    if (r->meno == NULL)
    {
        printf("Chyba pri alokaacii\n");
        exit(1);
    }

    memcpy(r->meno, meno, dllzhka);
    r->meno[dllzhka] = '\0';
    r->dllzhka = dllzhka;
    r->dhalshii = NULL;

    *r_pred = r;

    return (r);
}

void tabsym_znicsh_tabsym(tabsym *ts)
{
    for (; ts->velhkosth--;)
    {
        tabsym_r *r = ts->riadky[ts->velhkosth];
        tabsym_r *dr = NULL;

        for (; r; r = dr)
        {
            dr = r->dhalshii;
            free(r);
        }
    }

    free(ts->riadky);
    free(ts);
}
    
    
