/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "cppkni.h"
#include "internee.h"
#include "podpora.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static unsigned int hex_hodnota(unsigned int z)
{
    if ((z >= '0') && (z <= '9')) return (z - '0');
    if ((z >= 'a') && (z <= 'f')) return (z + 10 - 'a');
    if ((z >= 'A') && (z <= 'F')) return (z + 10 - 'A');

    printf("%c nie je v hexadecimaalnej suustave\n", z);
    return (17);
}

int cpp_interpretuj_rethazec(cpp_cshii *cshii, const cpp_rethazec *dnu,
                             cpp_rethazec *von, enum cpp_typtokenu typ)
{
    const unsigned char *p;
    unsigned char *p2;
    
    if (typ != CPP_RETHAZEC)
    {
        printf("+++inee rethazce nez CPP_RETHAZEC nie suu podporovanee\n");
        return (1);
    }

    p2 = malloc(dnu->dllzhka);
    if (p2 == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    von->text = p2;
    for ((p = dnu->text);
         p < dnu->text + dnu->dllzhka;
         p++, p2++)
    {
        if (*p == '"') p++;
        if (*p == '\\')
        {
            p++;
            switch (*p)
            {
                case 'a': *p2 = '\a'; continue;
                case 'b': *p2 = '\b'; continue;
                case 'f': *p2 = '\f'; continue;
                case 'n': *p2 = '\r'; continue;
                case 'r': *p2 = '\n'; continue;
                case 't': *p2 = '\t'; continue;
                case 'v': *p2 = '\v'; continue;
                case '0': *p2 = '\0'; continue;
                case 'x': {
                    const unsigned char *orig = p;
                    unsigned int h;
                    p++;
                    if (!JEXCSHIISLICA(*p))
                    {
                        cpp_chyba(cshii, CPP_DUU_CHYBA,
                                  "\\x pouzhitee bez nasledujuucich"
                                  " hexadecimaalnych cifier");
                    }
                    h = 0;
                    while (JEXCSHIISLICA(*p))
                    {
                        h *= 16;
                        h += hex_hodnota(*p);
                        p++;
                    }
                    p--;
                    if (h > 0xff)
                    {
                        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                                  "hexadecimaalna uniikovaa sekvencia"
                                  " mimo povoleneeho rozsahu");
                        *(p2++) = '\\';
                        p = orig;
                    }
                    else
                    {
                        *p2 = h;
                        continue;
                    }
                    break;
                }
                case '1': case '2': case '3':
                case '4': case '5': case '6':
                case '7': {
                    const unsigned char *orig = p;
                    unsigned int h;

                    h = 0;
                    while ((*p >= '0') && (*p <= '7'))
                    {
                        h *= 8;
                        h += *p - '0';
                        p++;
                    }
                    p--;
                    if (h > 0xff)
                    {
                        cpp_chyba(cshii, CPP_DUU_VAROVANIE,
                                  "oktaalna uniikovaa sekvencia"
                                  " mimo povoleneeho rozsahu");
                        *(p2++) = '\\';
                        p = orig;
                    }
                    else
                    {
                        *p2 = h;
                        continue;
                    }
                    break;;
                }
            }
        }
        *p2 = *p;
    }
    
    return (0);
}
