/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "include_cesta.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

include_cesty *ic_vytvor_include_cesty(void)
{
    int i;
    include_cesty *ic = malloc(sizeof(*ic));

    if (ic == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    for (i = 0; i < INCLUDE_CESTA_MAX; i++)
    {
        ic->shtarty[i] = NULL;
        ic->konce[i] = NULL;
    }

    return (ic);
}

void ic_pridaj_cpp_adr_do_rethaze(include_cesty *ic, cpp_adresaar *adr,
                                  enum include_cesta_typ typ)
{
    if (ic->konce[typ]) ic->konce[typ]->dhalshii = adr;
    else ic->shtarty[typ] = adr;

    ic->konce[typ] = adr;
}

/* cesta musii ukazovath na permanentne alokovanyy rethazec. */
void ic_pridaj_cestu(include_cesty *ic, char *cesta,
                     enum include_cesta_typ typ)
{
    cpp_adresaar *adr;
    /* Odstraani prebytochsnee lomky na konci cesty. */
    size_t dllzhka = strlen(cesta);
    char *koniec = cesta + dllzhka - 1;
    char *shtart = cesta + (((dllzhka > 2) && (cesta[1] == ':')) ? 3 : 1);

    for (;
         (koniec > shtart) && ((*koniec == '\\') || (*koniec == '/'));
         koniec--)
    {
        *koniec = '\0';
    }

    adr = malloc(sizeof(*adr));
    if (adr == NULL)
    {
        printf("Chyba pri alokaacii\n");
        abort();
    }

    adr->dhalshii = NULL;
    adr->meno = cesta;

    ic_pridaj_cpp_adr_do_rethaze(ic, adr, typ);
}

static void zluucsh_cesty(include_cesty *ic)
{
    if (ic->konce[INCLUDE_CESTA_SYSTEEM])
        (ic->konce[INCLUDE_CESTA_SYSTEEM]->dhalshii
         = ic->shtarty[INCLUDE_CESTA_PO_SYSTEEM]);
    else
        (ic->shtarty[INCLUDE_CESTA_SYSTEEM]
         = ic->shtarty[INCLUDE_CESTA_PO_SYSTEEM]);

    if (ic->konce[INCLUDE_CESTA_SHIKMEE])
        (ic->konce[INCLUDE_CESTA_SHIKMEE]->dhalshii
         = ic->shtarty[INCLUDE_CESTA_SYSTEEM]);
    else
        (ic->shtarty[INCLUDE_CESTA_SHIKMEE]
         = ic->shtarty[INCLUDE_CESTA_SYSTEEM]);

    if (ic->konce[INCLUDE_CESTA_UUVODZOVKY])
        (ic->konce[INCLUDE_CESTA_UUVODZOVKY]->dhalshii
         = ic->shtarty[INCLUDE_CESTA_SHIKMEE]);
    else
        (ic->shtarty[INCLUDE_CESTA_UUVODZOVKY]
         = ic->shtarty[INCLUDE_CESTA_SHIKMEE]);
}

void ic_registruj_include_rethaze(include_cesty *ic, cpp_cshii *cshii)
{
    zluucsh_cesty(ic);

    cpp_nastav_include_rethaze(cshii, ic->shtarty[INCLUDE_CESTA_UUVODZOVKY],
                               ic->shtarty[INCLUDE_CESTA_SHIKMEE], 0);
}
